# medz/plugs.py
#
#

""" medz plugins. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from medz.scheduler import Dispatcher
from medz.helpers.other import error
from medz import Thing

import importlib
import logging
import pkgutil

## PLUGINS

class Plugs(Dispatcher):

    """ ding to registreer plugins with. """

    def load(zelf, modname):
        """ load plugins from the plugin directory. """
        logging.warn("# plug %s" % modname)
        mod = zelf.load_mod(modname)
        for pkg in pkgutil.walk_packages(mod.__path__, mod.__name__+'.'):
            name = pkg[1]
            zelf[name] = zelf.load_mod(name, modname)

    def init(zelf, plugs):
        if not plugs: return
        modnames = plugs.split(",") 
        for modname in sorted(modnames, reverse=True):
            if not modname: continue
            objs = zelf.find(modname)
            for obj in objs:
                logging.warn("# init %s" % modname)
                if modname == "xmpp": obj.init() ; continue
                init = getattr(obj, "init", None)
                if init: zelf.put(obj.init)

    def stop(zelf, plugs):
        modnames = plugs.split(",") 
        for name in sorted(modnames)[::-1]:
            modnames = zelf.get_name(name)
            for name in modnames:
                obj = zelf.get(name)
                if not obj: continue
                try: obj.stop()
                except: pass

    def load_mod(zelf, name, package=None, force=True):
        """ load module. """
        logging.info("! mod %s" % ".".join(name.split(".")[1:]))
        if name in zelf and not force: mod = zelf.reload(name)
        else: mod = importlib.import_module(name, package)
        return mod

    def reload(zelf, *args, **kwargs):
        name = args[0]
        logging.warn("# reload %s" % name)
        zelf[name] = importlib.reload(zelf[name])
        return zelf[name]

    def get_name(zelf, *args, **kwargs):
        n = args[0]
        for name in zelf.names():
            if n in name: yield name

    def reload_name(zelf, *args, **kwargs):
        names = zelf.get_name(args[0])
        for name in names: zelf.reload(name)
