# medz/plugs/write.py
#
#

""" commenting. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from medz.helpers.time import short_date, ftime
from medz.helpers.mail import parse_email
from medz.helpers.parse import txt_parse
from medz.helpers.other import error
from medz.helpers.url import get_url
from medz.helpers.join import j

from medz.runtime import kernel
from medz import Thing

import email.message
import datetime
import mailbox
import socket
import email
import time
import os

## CMNDS

def write_add(event):
    rest = event.rest()
    try: key, value = rest.split(" ", 1)
    except ValueError: return
    o = Thing()
    if key in dir(o): event.reply("%s already defined in default Thing" % key) ; return
    o.prefix = "things"   
    o[key] = value
    path = o.save()
    event.ok(path)

kernel.register("write.add", write_add)

def write_comment(event):
    objs = event.selected()
    if not objs: return
    obj = objs[0]
    if "comment" not in obj: obj.comment = []
    obj.comment.append(" ".join(event.args[2:]))
    obj.sync()
    event.ok()

kernel.register("write.comment", write_comment)

def write_log(event):
    o = Thing()
    o.prefix = "log"
    o.log = event.txt
    path = o.save()
    event.ok()

kernel.register("write.log", write_log)

def write_status(event):
    o = Thing()
    o.prefix = "status"
    o.karma = event._parsed.karma
    o.status = event.rest()
    o.save()
    event.ok()

kernel.register("write.status", write_status)

