# medz/runtime.py
#
#

""" Not Your Will. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from medz.helpers.opts import make_opts, opts_defs
from medz.helpers.other import hello, error
from medz.scheduler import Dispatcher
from medz.log import init
from medz.plugs import Plugs
from medz.cfg import cfg_kernel
from medz import Thing

import logging
import time
import sys
import os

def medzpath():
    for path in sys.path:
        if "medz" in path and "egg" in path: yield path  

## Hemel

class Kernel(Plugs):

    def boot(zelf, *args, **kwargs):
        zelf.starttime = time.time()
        opts, arglist = make_opts(opts_defs)
        cfg.update(cfg_kernel)
        cfg.update(vars(opts))
        cfg.runargs = arglist
        cfg.shell = True
        if arglist: cfg.shell = False
        if cfg.shell and args: hello(*args, **kwargs)
        init(cfg.loglevel)
        if cfg.loglevel != "error":
            print("\n".join(sorted(cfg.show())))
            print("")
        logging.debug("path %s" % ", ".join(list(medzpath()))) 
        for package in cfg.packages:
            try: plugs.load(package)
            except: error()
        plugs.init(cfg.init)
        zelf.ready()
        return zelf

    def shutdown(zelf, *args, **kwargs): logging.warn("# shutdown")

## DEFINITIES

kernel = Kernel()
plugs = Plugs()
cfg = Thing()
fleet = []
